********************************************************************
*                       VFLIP.S                                    *
*          Program to flip the grob vertically                     *
*                   By Robert Tiismus                              *
*                  robert@physic.ut.ee                             *
*                                                                  *
*              Last change: October 1998                           *
*                                                                  *
*  In: Original GROB                                               *
* Out: Vertically flipped grob.                                    *
********************************************************************

ASSEMBLE
INTEMP? EQU     #06B3E
RPL
::
 CK1&Dispatch grob
 ::
  INTEMP? ?SKIP
  TOTEMPOB
  CODE
	GOSBVL  =SAVPTR
	GOSBVL  =DisableIntr

	C=DAT1  A
	C=C+CON A,5
	D0=C
	A=DAT0  A
	A=A+C   A       A -> End of picture

	D0=D0+  5
	C=DAT0  A
	?C=0    A
	GOYES   ++
	D=C     A       D = count of lines

	D0=D0+  5
	C=DAT0  A
	?C=0    A
	GOYES   ++
	C=C+CON A,7
	CSRB.F  A
	CSRB.F  A
	CBIT=0  0       C = count of nibbles on the line

	A=A-C   A
	D1=A            D1 -> start of last line
	D0=D0+  5       D0 -> start of first line

	A=C     A
	ASRB.F  A
	A=A-1   A
	R1=A.F  A       R1 = nibble counter start value

	C=C+C   A
	R0=C.F  A       R0 = 2 * nibbles on line

	DSRB.F  A
	D=D-1   A       D = line counter
	GOC     ++      If single line -> just skip to end

--      C=R1.F  A
	B=C     A       B = nibble counter

-       A=DAT0  B       Change bytes on the line
	C=DAT1  B
	DAT0=C  B
	DAT1=A  B

	D1=D1+  2       Next byte
	D0=D0+  2

	B=B-1   A
	GONC    -

	A=R0.F  A
	CD1EX
	C=C-A   A
	D1=C

	D=D-1   A
	GONC    --

++      GOSBVL  =AllowIntr
	GOVLNG  =GETPTRLOOP
  ENDCODE
 ;
;
